<?php
class NotificationHandler
{	
	function getNotifications($monitor)
	{
		return $GLOBALS['PW_DB']->query('SELECT n.*, mon.host, mon.port, mon.name AS mon_name, m.lastsend, m.monitor AS m_mm, m.notification AS n_mm FROM notifications AS n, monitors AS mon, monitors_notifications_mm AS m 
			WHERE n.id = m.notification 
			AND mon.id = m.monitor AND m.monitor = ' . $monitor
		);
	}
	
	function sendNotifications($monitor)
	{
		if(is_numeric($monitor))
			$res = self::getNotifications($monitor);
		else
			$res = self::getNotifications($monitor['id']);
		while($row = $GLOBALS['PW_DB']->fetchAssoc($res))
		{
			if($row['lastsend'] < time() - $GLOBALS['PW_DB']->confVal('resend_period'))
			{
				if($row['type'] == 'sms')
				{
					$to = explode('|', $row['sendto'], 2);
					$to = $to[0] . '@' . $to[1];
				}
				else
				{
					$to = $row['sendto'];
				}
				$msg = sprintf($GLOBALS['PW_DB']->confVal('notifications_' . $row['type'] . '_msg'),
					$monitor['id'],
					$row['mon_name'],
					$row['host'],
					$row['port']
				);
				$subj = sprintf($GLOBALS['PW_DB']->confVal('notifications_' . $row['type'] . '_subject'),
					$monitor['id'],
					$row['mon_name'],
					$row['host'],
					$row['port']
				);
				$GLOBALS['PW_DB']->query('UPDATE monitors_notifications_mm SET lastsend=' . time() . ' WHERE monitor=' . $row['m_mm'] . ' AND notification=' . $row['n_mm']);
				echo $to . '<br />';
				echo($subj . '<br />' . $msg . '<br /><br />');
				mail($to, $subj, $msg);
			}
		}
	}

	function formatSMS($sendto)
	{
		list($p, $c) = explode('|', $sendto, 2);
		$p = '(' . substr($p, 0, 3) . ') ' . substr($p, 3, 3) . '-' . substr($p, 6, 4);
		return $p . ' (' . self::smsLookup($c) . ')';
	}
	
	// For PHP4...
	function smsLookup($email = null)
	{
		$arr = array(
			'txt.att.net' => 'AT&amp;T',
			'txt.bell.ca' => 'Bell Mobility',
			'myboostmobile.com' => 'Boost',
			'txt.att.net' => 'Cingular',
			'fido.ca' => 'Fido',
			'myhelio.com' => 'Helio',
			'text.mtsmobility.com' => 'MTS',
			'page.nextel.com' => 'Nextel',
			'pcs.rogers.com' => 'Rogers',
			'sms.sasktel.com' => 'SaskTel',
			'txt.bell.ca' => 'Solo Mobile',
			'messaging.sprintpcs.com' => 'Sprint',
			'msg.telus.com' => 'TELUS',
			'vtext.com' => 'Verizon',
			'vmobl.com' => 'Virgin (USA)',
			'vmobile.ca' => 'Virgin (CA)',
		);
		if($email != null)
			return $arr[$email];
		return $arr;
	}
}
?>