<?php
class ServiceChecker
{
	function checkPort($server, $port, &$errno, &$errstr)
	{
	    $conn = @fsockopen($server, $port, $errno, $errstr, 2);
	    if ($conn)
	    {
	        fclose($conn);
	        return true;
	    }
	    return false;
	}
	
	function getReport($orderBy = '', $dir = 'A')
	{
		$result = array();
		$res = $GLOBALS['PW_DB']->query(
			'SELECT mon.*, 
			(SELECT COUNT(*) FROM monitors_notifications_mm AS mm WHERE mm.monitor = mon.id) 
			AS notifications, 
			(SELECT COUNT(*) FROM logs WHERE logs.monitor = mon.id AND online = 1) 
			AS online, 
			(SELECT COUNT(*) FROM logs WHERE logs.monitor = mon.id AND online = 0) 
			AS offline,
			(SELECT MAX(timestamp) FROM `logs` WHERE logs.monitor = mon.id AND online = 0) 
			AS last_offline 
			FROM monitors AS mon'
		);
		while($row = $GLOBALS['PW_DB']->fetchAssoc($res))
		{
			$errno = 0;
			$errstr = '';
			$online = self::checkPort($row['host'], $row['port'], &$errno, &$errstr);
			
			$temp = array(
				'id' => $row['id'],
				'host' => $row['host'],
				'port' => $row['port'],
				'name' => $row['name'],
				'notifications' => $row['notifications'],
				'log_online' => $row['online'],
				'log_offline' => $row['offline'],
				'last_offline' => $row['last_offline'],
				'uptime_percent' => (intval($row['online']) + intval($row['offline'])) > 0 ? (intval($row['online']) / (intval($row['online']) + intval($row['offline']))) * 100 : 'NaN',
				'online' => $online,
				'errno' => $errno,
				'errstr' => $errstr,
			);
			
			$result[$temp[$orderBy]][] = $temp;
		}
		
		if(strtoupper($dir) == 'A')
			ksort($result);
		else
			krsort($result);
		return $result;	
	}
}
?>