<?php
class TableBuilder
{
	var $lookups;
	var $cols;
	
	function TableBuilder($cols, $lookups)
	{
		$this->cols = $cols;
		$this->lookups = $lookups;
	}
	
	function build($data)
	{
		$ret = array(
			'th' => array(),
			'tr' => array(),
		);
		
		foreach($this->cols as $k => $v)
		{
			$order = 'A';
			if($_POST['sort'] == $k && $_POST['dir'] == 'A')
				$order = 'D';
			$ret['th'][] = array(
				'field' => $k,
				'title' => $v,
				'order' => $order,
			);
		}
		
		foreach($data as $block)
		{
			foreach($block as $r)
			{
				$tr = array();
				foreach($this->cols as $col => $val)
					if(array_key_exists($col, $this->lookups))
						$tr[$col] = $this->lookups[$col][$r[$col]];
					else
						$tr[$col] = $r[$col];
				$ret['tr'][] = $tr;
			}
		}
		
		return $ret;
	}
}
?>