<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="content-language" content="en">
<title>phpWatch Documentation</title>
<link rel="stylesheet" type="text/css" href="../ui/style.css">
<style type="text/css">
<!--
#main-container p
{
	margin: 0px 0px 10px 0px;
}

.docs-content
{
	padding: 5px;
}

.docs-content-topic
{
	padding: 5px 5px 5px 15px;
}

.main-container-subheader
{
	display: block;
	height: 12px;
	margin: 0;
	padding: 3px 10px 4px 10px;
	background-color: #EBEBEB;
	border-top: 1px solid #999999;
	border-bottom: 1px solid #999999;
	color: #000000;
	font-size: 11px;
	font-weight: bold;
}

.main-container-topic
{
	display: block;
	height: 9px;
	margin: 0;
	padding: 3px 10px 4px 10px;
	background-color: #FBFBFB;


	color: #777777;
	font-size: 10px;
	font-weight: bold;
}

#main-container ul
{
	list-style-type: circle;
	padding-top: 0px;
}

code, pre
{
	color: #000099;

}
-->
</style>
</head>
<body>

<div id="header">
	<div id="logo">phpWatch Documentation</div>
	<div id="nav">Revised July 16, 2008</div>
</div>

<div id="message"></div>

<div id="main-container">
	<div id="main-container-header">Overview</div>
	<div class="docs-content">
	<p>This page is meant to give a basic overview of the phpWatch's functionality, how it can be used as-is, and how to integrate it into an existing script or system.</p>
	</div>
    <div class="main-container-subheader">Installation</div>
    <div class="main-container-topic">Step 1: Setting up the database</div>
	<div class="docs-content-topic">
	<p>The basic installation is very simple: chmod config.php to 777 and simply navigate to the <code>install</code> directory in your browser.  Fill in the database information and the setup will create the required tables and setup the configuration file as needed.</p>
	</div>
    <div class="main-container-topic">Step 2: Setting up the Cron Job/Scheduled Task</div>
	<div class="docs-content-topic">
	<p>The only required task beyond the automated install is to add <code>cron.php</code> as a cron job (Unix/Linux) or scheduled task (Windows).  This script checks service status and sends the required notifications if it is offline.  Any interval can be used to run the script.  The output is in HTML and can be put into a log file if needed.</p>
	</div>
	<div class="main-container-subheader">Classes and Methods</div>
	<div class="docs-content">
	<p>The vast majority of phpWatch's functionality lies in three base classes.  All are contained in the <code>classes</code> folder within the base phpWatch directory.  The following covers the methods that are most likely to be used when integrating phpWatch into another script.  For a full listing, review the code files.</p>
	</div>
	<div class="main-container-topic">DataBase - Database abstraction layer</div>
	<div class="docs-content-topic">
		<ul>
			<li><code>string <strong>confVal</strong>(string $name[, bool $force_new = false])</code>:<p>Returns the configuration value for <code>$name</code>.  If <code>$force_new</code> is set to <code>true</code>, it will re-query the database instead of using cached data.</p></li>
			<li><code>string <strong>sanitize</strong>(mixed $input[, string $type = 'string'])</code>:<p>Sanitizes <code>$input</code> by striping HTML tags and slashing quotes for strings.  If <code>$type</code> is set to 'numeric', it will be passed to <code>intval</code>.</p></li>
		</ul>
	</div>
	<div class="main-container-topic">NotificationHandler - Handles the sending of notifcation during a service outage.</div>
	<div class="docs-content-topic">
		<ul>
			<!--<li><code>resource <strong>getNotifications</strong>(integer $monitor)</code>:<br />Returns the result of a <code>mysql_query</code> fetching all the notifications to be sent during an outage of the monitor with id <code>$monitor</code>.  The fields returned are: <br />
			<code>notifications.*<br />
			monitors.host<br />
			monitors.port<br />
			monitors.name as mon_name<br />
			monitors_notifications_mm.lastsend<br />
			monitors_notifications_mm.monitor as m_mm<br />
			monitors_notifications_mm.notification as n_mm<br /></code>
			In general this function is not directly called from outside of the script but may be useful in some situations.
			</li>-->
			<li><code>void <strong>sendNotifications</strong>(mixed $monitor)</code>:<p>Sends notifications for $monitor (regardless of if it's currently online or offline) to all recipients who have not been notified in the last <code>resend_period_seconds</code> seconds (configuration value).  If <code>$monitor</code> is numeric, it's assumed to be the ID of the monitor to be queried. If <code>$monitor</code> is an array, it's assumed that the value of key <code>id</code> is the ID of the monitor.</p></li>
			<li><code>mixed <strong>smsLookup</strong>([$email = null])</code>:<p>If <code>$email</code> is not passed, returns a key-value array with keys as URLs for SMS gateways and values as the carrier name (i.e. 'vtext.com' =&gt; 'Verizon').  If <code>$email</code> is passed, and it exists as a key in the lookup table, the function returns the carrier name.</p></li>
		</ul>
	</div>
	<div class="main-container-topic">ServiceChecker</div>
	<div class="docs-content-topic">
		<ul>
			<li><code>bool <strong>checkPort</strong>($server, $port, &amp;$errno, &amp;$errstr)</code>:<p>Returns <code>true</code> if a connection to <code>$server:$port</code> could successfully be established.  If one could not, the function returns <code>false</code> and sets <code>$errno</code> to the error code and <code>$errstr</code> to the error string.</p></li>
			<li><code>array getReport([$orderBy = ''[, $dir = 'A']])</code>:<p>Possibly the most important function in phpWatch.  Returns an array of all services, block-grouped in the first dimension by <code>$orderBy</code>.  <code>$dir</code> can be either <code>A</code> or <code>D</code> for ascending or descending order respectively.  The valid <code>$orderBy</code> values are:</p>
				<p><ul>
					<li><code>id</code> - ID number</li>
					<li><code>host</code> - Hostname or IP of service</li>
					<li><code>port</code> - Port of service</li>
					<li><code>name</code> - Name of service</li>
					<li><code>notifications</code> - Number of notifications associated with the service</li>
					<li><code>log_online</code> - Number of times the service has been online during checks</li>
					<li><code>log_offline</code> - Number of times the service has been offline during checks</li>
					<li><code>last_offline</code> - Last time the service was online</li>
					<li><code>uptime_percent</code> - Percentage of uptime during checks (log_online / log_offline * 100)</li>
					<li><code>online</code> - If the service is currently online or offline (true/false)</li>
					<li><code>errno</code> - Current error-message number</li>
					<li><code>errstr</code> - Current error-message string</li>
				</ul></p>
				<p>An example of how the block-grouping works: If <code>getReport('online')</code> is called, it will return an array in the form:</p>
<pre>
array(
	'online' =&gt; array(
		array( ... ), // online server 1
		array( ... ), // online server 2
		...
	),
	'offline' =&gt; array(
		array( ... ), // offline server 1
		array( ... ), // offline server 2
		...
	)
)
</pre>
			</li>
		</ul>
	</div>
    <div class="main-container-subheader">Integration Example</div>
	<div class="docs-content">
		<p>This example is very short but should give some insight into how phpWatch can be integrated into an existing system or script.</p>
		<p>To simplify the process, only one file needs to be included to utilize all of phpWatch's functionality -- <code>common.php</code> located in the base directory.  This provides access to all of the classes discussed above and sets <code>$GLOBALS['PW_DB']</code> to the instantiated <code>DataBase</code> class.  A very basic script that will simply print if each service is online along with error information for those that are not:</p>
<pre>
require_once('path/to/phpWatch/common.php'); // Include the required file
$result = ServiceChecker::getReport('online'); // Gets a report of all services sorted by online.
foreach($result as $block) // Loops through each block (in this case 'online' and 'offline')
	foreach($block as $r) // Loops through each service within the current block
	{
		/*
			$r contains all the information about the current service.  The keys available
			are the same as the allowed sorting fields:
				- id
				- host
				- port
				- name
				- notifications
				- log_online
				- log_offline
				- last_offline
				- uptime_percent
				- online
				- errno
				- errstr
		*/
	 	echo $r['host'] . ':' . $r['port'] . ' is ';
		if($r['online'])
			echo 'online!';
		else
			echo 'offline! (' . $r['errno'] . ':' . $r['errstr'] . ')';
		echo '&lt;br /&gt;';
	}
</pre>
	</div>
    <div class="main-container-subheader">Notes on SMS</div>
	<div class="docs-content">
	<p>One of the key features that was included in phpWatch is the SMS functionality.  Many get confused by how this works so this section will briefly describe the method used.</p>
	<p>phpWatch uses pre-existing SMS gateways provided by the cell-carriers themselves.  For example, to send a message to a Verizon subscriber with the phone number 123-456-7890, an e-mail can be sent to 1234567890@vtext.com and it will then be forwarded to the individual's phone.</p>
	<p>In an upcoming version, a tool which allows individuals to send a text message to a pre-defined e-mail address that has all its e-mail piped to a script will be released.  This will allow authorized individuals to query phpWatch from an SMS-enabled phone.</p>
	</div>
	<div class="main-container-subheader">Credits</div>
	<div class="docs-content">
		<p>Developed by: Aaron Rosenfeld (<a href="mailto:aaron@aaron-rosenfeld.com">aaron@aaron-rosenfeld.com</a>)</p>
	</div>
	<div class="main-container-subheader">Change Log</div>
	<div class="main-container-topic">04/06/2009 - v1.0.8 Beta</div>
	<div class="docs-content-topic">
		<ul>
			<li>Corrected problem with notifactions being sent</li>
		</ul>
	</div>
	<div class="main-container-topic">03/13/2009 - v1.0.7 Beta</div>
	<div class="docs-content-topic">
		<ul>
			<li>Corrected problem that caused leading-zeros to be removed from telephone numbers</li>
		</ul>
	</div>
	<div class="main-container-topic">07/16/2008 - v1.0.6 Beta</div>
	<div class="docs-content-topic">
		<ul>
			<li>Fixed problem with auto-fill that caused errors when adding monitors</li>
		</ul>
	</div>
	<div class="main-container-topic">07/15/2008 - v1.0.5 Beta</div>
	<div class="docs-content-topic">
		<ul>
			<li>Initial Relase</li>
		</ul>
	</div>
</div>
<div id="footer-left">phpWatch v1.0.8 Beta</div>
<div id="footer-right"></div>

</body>
</html>