<?php
// This is the only required include for external scripts.
// It will give access to all the required classes and 
// database.
require_once('../common.php');

// Gets a report of all services being monitored.
// The prototype for this method is:
// getReport($orderBy = '', $dir = 'A')
//
// The returned result is an array containing 
// all services grouped by $orderBy.  That is,
// if $orderBy is set to 'online', the array would 
// look like:
// array(
// 	'online' => array(
// 		array( ... ), // online server 1
// 		array( ... ), // online server 2
// 		...
//	),
// 	'offline' => array(
// 		array( ... ), // offline server 1
// 		array( ... ), // offline server 2
// 		...
//	)
// )
$result = ServiceChecker::getReport();
foreach($result as $block)
	foreach($block as $r)
		echo $r['host'] . ':' . $r['port'] . ' = ' . ($r['online'] ? 'up' : 'down (' . $r['errno'] . ':' . $r['errstr'] . ')') . '<br />';
?>